Runbook Runs

Get a list of Runbook Runs

GET /api/{spaceId}/projects/{projectId}/runbookRuns

Also reachable at /api/projects/{projectId}/runbookRuns, /api/spaces/{spaceIdentifier}/projects/{projectId}/runbookRuns.

Lists all of the runbookRuns in the supplied Octopus Deploy Space, from projects, snapshots and environments accessible by the current user. The results will be sorted from most recent to least recent runbookRun.

Path Parameters

  • projectId string (required)
  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • environments array of string
    Environment Ids to filter results to only Runbook Runs with the given Environment Ids.
  • ids array of string
    Runbook Run Ids to filter results to only Runbook Runs with the given Ids.
  • partialName string
    A partial name, to limit the set of Runbook Runs to those with a name that includes the partial name.
  • projects array of string
    Project Ids to filter results to only Runbook Runs with the given Project Ids.
  • runbooks array of string
    Runbook Ids to filter results to only Runbooks with the given Ids.
  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 30. Minimum 0.
  • taskState enum
    Task State to filter results to only Deployments with the given Task State.
    Allowed values: Queued, Executing, Failed, Canceled, TimedOut, Success, Cancelling.
  • tenants array of string
    Tenant Ids to filter results to only Runbook Runs with the given Tenant Ids.

Response

200 — The requested list of Runbook Runs

  • Id string
    Gets or sets a unique identifier for this resource.
  • ItemType string
  • Items array of object
    • ChangeRequestSettings array of object
    • Comments string
    • Created string
      Format date-time.
    • DebugMode string
    • DeployedBy string
    • DeployedById string
    • DeployedToMachineIds array of string
    • EnvironmentId string
    • ExcludedMachineIds array of string
      A collection of machines in the target environment that should be excluded from the deployment.
    • ExcludedTargetTagIds array of string
      A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
    • ExecutionPlanLogContext object
    • FailTargetDiscovery boolean
    • FailureEncountered boolean
    • ForcePackageDownload boolean
    • FormValues object
    • FrozenRunbookProcessId string
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • ManifestVariableSetId string
    • Name string
    • Priority string
    • ProjectId string
    • QueueTime string
      If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Format date-time.
    • QueueTimeExpiry string
      Format date-time.
    • RunbookId string
      Minimum length 1.
    • RunbookName string
    • RunbookSnapshotId string
      Minimum length 1.
    • SkipActions array of string
    • SpaceId string
    • SpecificMachineIds array of string
      A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.
    • SpecificTargetTagIds array of string
      A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
    • TaskId string
    • TenantId string
    • TentacleRetentionPeriod object
    • UseGuidedFailure boolean
      If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
  • ItemsPerPage integer
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LastPageNumber integer
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • NumberOfPages integer
  • TotalResults integer

Example Response

JSON
{
  "Id": "string",
  "ItemType": "string",
  "Items": [
    {
      "ChangeRequestSettings": [
        {}
      ],
      "Comments": "string",
      "Created": "2020-01-01T00:00:00.000Z",
      "DebugMode": "string",
      "DeployedBy": "string",
      "DeployedById": "string",
      "DeployedToMachineIds": [
        "string"
      ],
      "EnvironmentId": "string",
      "ExcludedMachineIds": [
        "string"
      ],
      "ExcludedTargetTagIds": [
        "string"
      ],
      "ExecutionPlanLogContext": {
        "Steps": [
          {}
        ]
      },
      "FailTargetDiscovery": true,
      "FailureEncountered": true,
      "ForcePackageDownload": true,
      "FormValues": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "FrozenRunbookProcessId": "string",
      "Id": "string",
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "ManifestVariableSetId": "string",
      "Name": "string",
      "Priority": "string",
      "ProjectId": "string",
      "QueueTime": "2020-01-01T00:00:00.000Z",
      "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
      "RunbookId": "string",
      "RunbookName": "string",
      "RunbookSnapshotId": "string",
      "SkipActions": [
        "string"
      ],
      "SpaceId": "string",
      "SpecificMachineIds": [
        "string"
      ],
      "SpecificTargetTagIds": [
        "string"
      ],
      "TaskId": "string",
      "TenantId": "string",
      "TentacleRetentionPeriod": {
        "QuantityToKeep": 0,
        "ShouldKeepForever": true,
        "Strategy": "string",
        "Unit": "Days"
      },
      "UseGuidedFailure": true
    }
  ],
  "ItemsPerPage": 0,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LastPageNumber": 0,
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "NumberOfPages": 0,
  "TotalResults": 0
}

Create a new Runbook Run

POST /api/{spaceId}/projects/{projectId}/runbookRuns

Also reachable at /api/projects/{projectId}/runbookRuns, /api/spaces/{spaceIdentifier}/projects/{projectId}/runbookRuns.

Path Parameters

  • projectId string (required)
  • spaceId string (required)

Request Body

  • ChangeRequestSettings array of object
    • Type enum
      Allowed values: ServiceNow, JiraServiceManagement.
  • Comments string
  • DebugMode string
  • EnvironmentId string (required)
  • ExcludedMachineIds array of string
  • ExcludedTargetTagIds array of string
  • FailTargetDiscovery boolean
  • ForcePackageDownload boolean
  • FormValues object
  • Priority string
  • ProjectId string
  • QueueTime string
    Format date-time.
  • QueueTimeExpiry string
    Format date-time.
  • RunbookId string (required)
  • RunbookSnapshotId string (required)
  • SkipActions array of string
  • SpaceId string (required)
  • SpecificMachineIds array of string
  • SpecificTargetTagIds array of string
  • TenantId string
  • UseGuidedFailure boolean

Response

201 — Created

  • ChangeRequestSettings array of object
    • Type enum
      Allowed values: ServiceNow, JiraServiceManagement.
  • Comments string
  • Created string
    Format date-time.
  • DebugMode string
  • DeployedBy string
  • DeployedById string
  • DeployedToMachineIds array of string
  • EnvironmentId string
  • ExcludedMachineIds array of string
    A collection of machines in the target environment that should be excluded from the deployment.
  • ExcludedTargetTagIds array of string
    A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
  • ExecutionPlanLogContext object
    • Steps array of object
  • FailTargetDiscovery boolean
  • FailureEncountered boolean
  • ForcePackageDownload boolean
  • FormValues object
  • FrozenRunbookProcessId string
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • ManifestVariableSetId string
  • Name string
  • Priority string
  • ProjectId string
  • QueueTime string
    If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Format date-time.
  • QueueTimeExpiry string
    Format date-time.
  • RunbookId string
    Minimum length 1.
  • RunbookName string
  • RunbookSnapshotId string
    Minimum length 1.
  • SkipActions array of string
  • SpaceId string
  • SpecificMachineIds array of string
    A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.
  • SpecificTargetTagIds array of string
    A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
  • TaskId string
  • TenantId string
  • TentacleRetentionPeriod object
    • QuantityToKeep integer
    • ShouldKeepForever boolean
    • Strategy string
    • Unit enum
      Allowed values: Days, Items.
  • UseGuidedFailure boolean
    If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.

Example Request

JSON
{
  "ChangeRequestSettings": [
    {
      "Type": "ServiceNow"
    }
  ],
  "Comments": "string",
  "DebugMode": "string",
  "EnvironmentId": "string",
  "ExcludedMachineIds": [
    "string"
  ],
  "ExcludedTargetTagIds": [
    "string"
  ],
  "FailTargetDiscovery": true,
  "ForcePackageDownload": true,
  "FormValues": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Priority": "string",
  "ProjectId": "string",
  "QueueTime": "2020-01-01T00:00:00.000Z",
  "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
  "RunbookId": "string",
  "RunbookSnapshotId": "string",
  "SkipActions": [
    "string"
  ],
  "SpaceId": "string",
  "SpecificMachineIds": [
    "string"
  ],
  "SpecificTargetTagIds": [
    "string"
  ],
  "TenantId": "string",
  "UseGuidedFailure": true
}

Example Response

JSON
{
  "ChangeRequestSettings": [
    {
      "Type": "ServiceNow"
    }
  ],
  "Comments": "string",
  "Created": "2020-01-01T00:00:00.000Z",
  "DebugMode": "string",
  "DeployedBy": "string",
  "DeployedById": "string",
  "DeployedToMachineIds": [
    "string"
  ],
  "EnvironmentId": "string",
  "ExcludedMachineIds": [
    "string"
  ],
  "ExcludedTargetTagIds": [
    "string"
  ],
  "ExecutionPlanLogContext": {
    "Steps": [
      {
        "CorrelationId": "string",
        "Slug": "string"
      }
    ]
  },
  "FailTargetDiscovery": true,
  "FailureEncountered": true,
  "ForcePackageDownload": true,
  "FormValues": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "FrozenRunbookProcessId": "string",
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "ManifestVariableSetId": "string",
  "Name": "string",
  "Priority": "string",
  "ProjectId": "string",
  "QueueTime": "2020-01-01T00:00:00.000Z",
  "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
  "RunbookId": "string",
  "RunbookName": "string",
  "RunbookSnapshotId": "string",
  "SkipActions": [
    "string"
  ],
  "SpaceId": "string",
  "SpecificMachineIds": [
    "string"
  ],
  "SpecificTargetTagIds": [
    "string"
  ],
  "TaskId": "string",
  "TenantId": "string",
  "TentacleRetentionPeriod": {
    "QuantityToKeep": 0,
    "ShouldKeepForever": true,
    "Strategy": "string",
    "Unit": "Days"
  },
  "UseGuidedFailure": true
}

Get a Runbook Run by ID

GET /api/{spaceId}/projects/{projectId}/runbookRuns/{id}

Also reachable at /api/projects/{projectId}/runbookRuns/{id}, /api/spaces/{spaceIdentifier}/projects/{projectId}/runbookRuns/{id}.

Path Parameters

  • id string (required)
    ID of the Runbook Run to load.
  • projectId string (required)
    ID of the Project to which the Runbook Run belongs.
  • spaceId string (required)
    ID of the Space to which the Runbook Run belongs.

Response

200 — The requested Runbook Run

  • ChangeRequestSettings array of object
    • Type enum
      Allowed values: ServiceNow, JiraServiceManagement.
  • Comments string
  • Created string
    Format date-time.
  • DebugMode string
  • DeployedBy string
  • DeployedById string
  • DeployedToMachineIds array of string
  • EnvironmentId string
  • ExcludedMachineIds array of string
    A collection of machines in the target environment that should be excluded from the deployment.
  • ExcludedTargetTagIds array of string
    A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
  • ExecutionPlanLogContext object
    • Steps array of object
  • FailTargetDiscovery boolean
  • FailureEncountered boolean
  • ForcePackageDownload boolean
  • FormValues object
  • FrozenRunbookProcessId string
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • ManifestVariableSetId string
  • Name string
  • Priority string
  • ProjectId string
  • QueueTime string
    If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Format date-time.
  • QueueTimeExpiry string
    Format date-time.
  • RunbookId string
    Minimum length 1.
  • RunbookName string
  • RunbookSnapshotId string
    Minimum length 1.
  • SkipActions array of string
  • SpaceId string
  • SpecificMachineIds array of string
    A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.
  • SpecificTargetTagIds array of string
    A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
  • TaskId string
  • TenantId string
  • TentacleRetentionPeriod object
    • QuantityToKeep integer
    • ShouldKeepForever boolean
    • Strategy string
    • Unit enum
      Allowed values: Days, Items.
  • UseGuidedFailure boolean
    If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.

Example Response

JSON
{
  "ChangeRequestSettings": [
    {
      "Type": "ServiceNow"
    }
  ],
  "Comments": "string",
  "Created": "2020-01-01T00:00:00.000Z",
  "DebugMode": "string",
  "DeployedBy": "string",
  "DeployedById": "string",
  "DeployedToMachineIds": [
    "string"
  ],
  "EnvironmentId": "string",
  "ExcludedMachineIds": [
    "string"
  ],
  "ExcludedTargetTagIds": [
    "string"
  ],
  "ExecutionPlanLogContext": {
    "Steps": [
      {
        "CorrelationId": "string",
        "Slug": "string"
      }
    ]
  },
  "FailTargetDiscovery": true,
  "FailureEncountered": true,
  "ForcePackageDownload": true,
  "FormValues": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "FrozenRunbookProcessId": "string",
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "ManifestVariableSetId": "string",
  "Name": "string",
  "Priority": "string",
  "ProjectId": "string",
  "QueueTime": "2020-01-01T00:00:00.000Z",
  "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
  "RunbookId": "string",
  "RunbookName": "string",
  "RunbookSnapshotId": "string",
  "SkipActions": [
    "string"
  ],
  "SpaceId": "string",
  "SpecificMachineIds": [
    "string"
  ],
  "SpecificTargetTagIds": [
    "string"
  ],
  "TaskId": "string",
  "TenantId": "string",
  "TentacleRetentionPeriod": {
    "QuantityToKeep": 0,
    "ShouldKeepForever": true,
    "Strategy": "string",
    "Unit": "Days"
  },
  "UseGuidedFailure": true
}

Delete an existing Runbook Run

DELETE /api/{spaceId}/projects/{projectId}/runbookruns/{id}

Also reachable at /api/projects/{projectId}/runbookruns/{id}, /api/spaces/{spaceIdentifier}/projects/{projectId}/runbookruns/{id}.

Path Parameters

  • id string (required)
    ID of the Runbook Run to delete.
  • projectId string (required)
    ID of the Project to which the Runbook Run belongs.
  • spaceId string (required)
    ID of the Space to which the Runbook Run belongs.

Response

200 — Success

Create a new Runbook run based on an existing runbook run

POST /api/{spaceId}/projects/{projectId}/runbookruns/{runbookRunId}/retry/v1

Also reachable at /api/projects/{projectId}/runbookruns/{runbookRunId}/retry/v1, /api/spaces/{spaceIdentifier}/projects/{projectId}/runbookruns/{runbookRunId}/retry/v1.

Path Parameters

  • projectId string (required)
  • runbookRunId string (required)
  • spaceId string (required)

Response

200 — Runbook run that was retried

  • Resource object
    • ChangeRequestSettings array of object
    • Comments string
    • Created string
      Format date-time.
    • DebugMode string
    • DeployedBy string
    • DeployedById string
    • DeployedToMachineIds array of string
    • EnvironmentId string
    • ExcludedMachineIds array of string
      A collection of machines in the target environment that should be excluded from the deployment.
    • ExcludedTargetTagIds array of string
      A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
    • ExecutionPlanLogContext object
    • FailTargetDiscovery boolean
    • FailureEncountered boolean
    • ForcePackageDownload boolean
    • FormValues object
    • FrozenRunbookProcessId string
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • ManifestVariableSetId string
    • Name string
    • Priority string
    • ProjectId string
    • QueueTime string
      If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Format date-time.
    • QueueTimeExpiry string
      Format date-time.
    • RunbookId string
      Minimum length 1.
    • RunbookName string
    • RunbookSnapshotId string
      Minimum length 1.
    • SkipActions array of string
    • SpaceId string
    • SpecificMachineIds array of string
      A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.
    • SpecificTargetTagIds array of string
      A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
    • TaskId string
    • TenantId string
    • TentacleRetentionPeriod object
    • UseGuidedFailure boolean
      If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.

Example Response

JSON
{
  "Resource": {
    "ChangeRequestSettings": [
      {
        "Type": "ServiceNow"
      }
    ],
    "Comments": "string",
    "Created": "2020-01-01T00:00:00.000Z",
    "DebugMode": "string",
    "DeployedBy": "string",
    "DeployedById": "string",
    "DeployedToMachineIds": [
      "string"
    ],
    "EnvironmentId": "string",
    "ExcludedMachineIds": [
      "string"
    ],
    "ExcludedTargetTagIds": [
      "string"
    ],
    "ExecutionPlanLogContext": {
      "Steps": [
        {}
      ]
    },
    "FailTargetDiscovery": true,
    "FailureEncountered": true,
    "ForcePackageDownload": true,
    "FormValues": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    },
    "FrozenRunbookProcessId": "string",
    "Id": "string",
    "LastModifiedBy": "string",
    "LastModifiedOn": "2020-01-01T00:00:00.000Z",
    "Links": {
      "additionalProp1": "string",
      "additionalProp2": "string",
      "additionalProp3": "string"
    },
    "ManifestVariableSetId": "string",
    "Name": "string",
    "Priority": "string",
    "ProjectId": "string",
    "QueueTime": "2020-01-01T00:00:00.000Z",
    "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
    "RunbookId": "string",
    "RunbookName": "string",
    "RunbookSnapshotId": "string",
    "SkipActions": [
      "string"
    ],
    "SpaceId": "string",
    "SpecificMachineIds": [
      "string"
    ],
    "SpecificTargetTagIds": [
      "string"
    ],
    "TaskId": "string",
    "TenantId": "string",
    "TentacleRetentionPeriod": {
      "QuantityToKeep": 0,
      "ShouldKeepForever": true,
      "Strategy": "string",
      "Unit": "Days"
    },
    "UseGuidedFailure": true
  }
}

Create a new Runbook Run

POST /api/{spaceId}/projects/{projectId}/{gitRef}/runbooks/{runbookId}/run/v1

Also reachable at /api/projects/{projectId}/{gitRef}/runbooks/{runbookId}/run/v1, /api/spaces/{spaceIdentifier}/projects/{projectId}/{gitRef}/runbooks/{runbookId}/run/v1.

Path Parameters

  • gitRef string (required)
  • projectId string (required)
  • runbookId string (required)
  • spaceId string (required)

Request Body

  • GitRef string (required)
  • Notes string
  • ProjectId string (required)
  • RunbookId string (required)
  • Runs array of object (required)
    • ChangeRequestSettings array of object
    • Comments string
    • DebugMode string
    • EnvironmentId string (required)
    • ExcludedMachineIds array of string
    • ExcludedTargetTagIds array of string
    • FailTargetDiscovery boolean
    • ForcePackageDownload boolean
    • FormValues object
    • Priority string
    • QueueTime string
      Format date-time.
    • QueueTimeExpiry string
      Format date-time.
    • SkipActions array of string
    • SpecificMachineIds array of string
    • SpecificTargetTagIds array of string
    • TenantId string
    • UseGuidedFailure boolean
  • SelectedGitResources array of object
    • ActionName string (required)
      Minimum length 1.
    • GitReferenceResource object (required)
    • GitResourceReferenceName string
  • SelectedPackages array of object
    • ActionName string
    • PackageReferenceName string
    • StepName string
    • Version string
  • SpaceId string (required)

Response

200 — The newly-created Runbook run

  • Resources array of object
    • ChangeRequestSettings array of object
    • Comments string
    • Created string
      Format date-time.
    • DebugMode string
    • DeployedBy string
    • DeployedById string
    • DeployedToMachineIds array of string
    • EnvironmentId string
    • ExcludedMachineIds array of string
      A collection of machines in the target environment that should be excluded from the deployment.
    • ExcludedTargetTagIds array of string
      A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
    • ExecutionPlanLogContext object
    • FailTargetDiscovery boolean
    • FailureEncountered boolean
    • ForcePackageDownload boolean
    • FormValues object
    • FrozenRunbookProcessId string
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • ManifestVariableSetId string
    • Name string
    • Priority string
    • ProjectId string
    • QueueTime string
      If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Format date-time.
    • QueueTimeExpiry string
      Format date-time.
    • RunbookId string
      Minimum length 1.
    • RunbookName string
    • RunbookSnapshotId string
      Minimum length 1.
    • SkipActions array of string
    • SpaceId string
    • SpecificMachineIds array of string
      A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.
    • SpecificTargetTagIds array of string
      A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
    • TaskId string
    • TenantId string
    • TentacleRetentionPeriod object
    • UseGuidedFailure boolean
      If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.

Example Request

JSON
{
  "GitRef": "string",
  "Notes": "string",
  "ProjectId": "string",
  "RunbookId": "string",
  "Runs": [
    {
      "ChangeRequestSettings": [
        {}
      ],
      "Comments": "string",
      "DebugMode": "string",
      "EnvironmentId": "string",
      "ExcludedMachineIds": [
        "string"
      ],
      "ExcludedTargetTagIds": [
        "string"
      ],
      "FailTargetDiscovery": true,
      "ForcePackageDownload": true,
      "FormValues": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "Priority": "string",
      "QueueTime": "2020-01-01T00:00:00.000Z",
      "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
      "SkipActions": [
        "string"
      ],
      "SpecificMachineIds": [
        "string"
      ],
      "SpecificTargetTagIds": [
        "string"
      ],
      "TenantId": "string",
      "UseGuidedFailure": true
    }
  ],
  "SelectedGitResources": [
    {
      "ActionName": "string",
      "GitReferenceResource": {
        "GitCommit": "string",
        "GitRef": "string"
      },
      "GitResourceReferenceName": "string"
    }
  ],
  "SelectedPackages": [
    {
      "ActionName": "string",
      "PackageReferenceName": "string",
      "StepName": "string",
      "Version": "string"
    }
  ],
  "SpaceId": "string"
}

Example Response

JSON
{
  "Resources": [
    {
      "ChangeRequestSettings": [
        {}
      ],
      "Comments": "string",
      "Created": "2020-01-01T00:00:00.000Z",
      "DebugMode": "string",
      "DeployedBy": "string",
      "DeployedById": "string",
      "DeployedToMachineIds": [
        "string"
      ],
      "EnvironmentId": "string",
      "ExcludedMachineIds": [
        "string"
      ],
      "ExcludedTargetTagIds": [
        "string"
      ],
      "ExecutionPlanLogContext": {
        "Steps": [
          {}
        ]
      },
      "FailTargetDiscovery": true,
      "FailureEncountered": true,
      "ForcePackageDownload": true,
      "FormValues": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "FrozenRunbookProcessId": "string",
      "Id": "string",
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "ManifestVariableSetId": "string",
      "Name": "string",
      "Priority": "string",
      "ProjectId": "string",
      "QueueTime": "2020-01-01T00:00:00.000Z",
      "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
      "RunbookId": "string",
      "RunbookName": "string",
      "RunbookSnapshotId": "string",
      "SkipActions": [
        "string"
      ],
      "SpaceId": "string",
      "SpecificMachineIds": [
        "string"
      ],
      "SpecificTargetTagIds": [
        "string"
      ],
      "TaskId": "string",
      "TenantId": "string",
      "TentacleRetentionPeriod": {
        "QuantityToKeep": 0,
        "ShouldKeepForever": true,
        "Strategy": "string",
        "Unit": "Days"
      },
      "UseGuidedFailure": true
    }
  ]
}

Create a new runbook run

POST /api/{spaceId}/runbook-runs/create/v1

Also reachable at /api/runbook-runs/create/v1, /api/spaces/{spaceIdentifier}/runbook-runs/create/v1.

Path Parameters

  • spaceId string (required)

Request Body

  • DebugMode string
    Contributes the OctopusPrintVariables and OctopusPrintEvaluatedVariables variables to the execution. One of “None”, “Log” or “Debug”; leave unset for the default of “None”.
  • DeploymentFreezeNames array of string
    Active deployment freezes to override so this execution can proceed despite them. Overriding a freeze bypasses a deliberate block on deploying, so only set this when explicitly asked to. Requires DeploymentFreezeOverrideReason.
  • DeploymentFreezeOverrideReason string
    Required, and must not be blank, whenever DeploymentFreezeNames is non-empty. Recorded against the override.
  • EnvironmentNames array of string (required)
  • ExcludedMachineNames array of string
    A collection of machines in the target environment that should be excluded from the deployment.
  • ExcludedTargetTagNames array of string
    A collection of deployment target tags (canonical names in format TagSetName/TagName) that should be excluded from the deployment.
  • ForcePackageDownload boolean
    Whether to force downloading of already installed packages (flag, default false).
  • NoRunAfter string
    Time at which a scheduled execution should expire if it has not started, specified as any valid DateTimeOffset format, and assuming the time zone is the current local time zone. Only meaningful alongside RunAt. Format date-time.
  • Priority string
    Whether this execution jumps the task queue ahead of other queued tasks. One of “LifecycleDefault” (use the lifecycle’s configured setting), “On” or “Off”.
  • ProjectName string (required)
  • RunAt string
    Time at which the execution should start (scheduling it for later), specified as any valid DateTimeOffset format, and assuming the time zone is the current local time zone. Format date-time.
  • RunbookName string (required)
  • SkipStepNames array of string
    Steps that are to be skipped for this execution. A name that matches no step is logged as a warning rather than failing the command, so check the step name carefully.
  • Snapshot string
    Name or ID of the snapshot to run. If not supplied, the command will attempt to use the published snapshot.
  • SpaceId string (required)
  • SpaceIdOrName string (required)
    Both this and SpaceId are required, and normally hold the same space ID; set both.
  • SpecificMachineNames array of string
    A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed. A name that matches no machine fails the command.
  • SpecificTargetTagNames array of string
    A collection of deployment target tags (canonical names in format TagSetName/TagName) that should be included in the deployment.
  • TenantTags array of string
    The tenant tags to filter tenants to deploy.
  • Tenants array of string
    The tenants to deploy.
  • UseGuidedFailure boolean
    If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
  • Variables object
    Name/value pairs for prompted variables. A prompted variable that is required and has no value supplied here fails the command, naming the variable.

Response

200 — Server tasks associated with the newly-created Runbook Run

  • RunbookRunServerTasks array of object
    • RunbookRunId string
    • ServerTaskId string

Example Request

JSON
{
  "DebugMode": "string",
  "DeploymentFreezeNames": [
    "string"
  ],
  "DeploymentFreezeOverrideReason": "string",
  "EnvironmentNames": [
    "string"
  ],
  "ExcludedMachineNames": [
    "string"
  ],
  "ExcludedTargetTagNames": [
    "string"
  ],
  "ForcePackageDownload": true,
  "NoRunAfter": "2020-01-01T00:00:00.000Z",
  "Priority": "string",
  "ProjectName": "string",
  "RunAt": "2020-01-01T00:00:00.000Z",
  "RunbookName": "string",
  "SkipStepNames": [
    "string"
  ],
  "Snapshot": "string",
  "SpaceId": "string",
  "SpaceIdOrName": "string",
  "SpecificMachineNames": [
    "string"
  ],
  "SpecificTargetTagNames": [
    "string"
  ],
  "TenantTags": [
    "string"
  ],
  "Tenants": [
    "string"
  ],
  "UseGuidedFailure": true,
  "Variables": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  }
}

Example Response

JSON
{
  "RunbookRunServerTasks": [
    {
      "RunbookRunId": "string",
      "ServerTaskId": "string"
    }
  ]
}

Get a list of Runbook Runs

GET /api/{spaceId}/runbookRuns

Also reachable at /api/runbookRuns, /api/spaces/{spaceIdentifier}/runbookRuns.

Lists all of the runbookRuns in the supplied Octopus Deploy Space, from projects, snapshots and environments accessible by the current user. The results will be sorted from most recent to least recent runbookRun.

Path Parameters

  • spaceId string (required)
    The ID of the space containing the resource(s).

Query Parameters

  • environments array of string
    Environment Ids to filter results to only Runbook Runs with the given Environment Ids.
  • ids array of string
    Runbook Run Ids to filter results to only Runbook Runs with the given Ids.
  • partialName string
    A partial name, to limit the set of Runbook Runs to those with a name that includes the partial name.
  • projects array of string
    Project Ids to filter results to only Runbook Runs with the given Project Ids.
  • runbooks array of string
    Runbook Ids to filter results to only Runbooks with the given Ids.
  • skip integer
    Number of items to skip. Defaults to zero. Minimum 0.
  • take integer
    Number of items to take. Defaults to 30. Minimum 0.
  • taskState enum
    Task State to filter results to only Deployments with the given Task State.
    Allowed values: Queued, Executing, Failed, Canceled, TimedOut, Success, Cancelling.
  • tenants array of string
    Tenant Ids to filter results to only Runbook Runs with the given Tenant Ids.

Response

200 — The requested list of Runbook Runs

  • Id string
    Gets or sets a unique identifier for this resource.
  • ItemType string
  • Items array of object
    • ChangeRequestSettings array of object
    • Comments string
    • Created string
      Format date-time.
    • DebugMode string
    • DeployedBy string
    • DeployedById string
    • DeployedToMachineIds array of string
    • EnvironmentId string
    • ExcludedMachineIds array of string
      A collection of machines in the target environment that should be excluded from the deployment.
    • ExcludedTargetTagIds array of string
      A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
    • ExecutionPlanLogContext object
    • FailTargetDiscovery boolean
    • FailureEncountered boolean
    • ForcePackageDownload boolean
    • FormValues object
    • FrozenRunbookProcessId string
    • Id string
      Gets or sets a unique identifier for this resource.
    • LastModifiedBy string
      Gets or sets the username of the user who last modified this resource.
    • LastModifiedOn string
      Gets or sets the date/time that this resource was last modified. Format date-time.
    • Links object
      Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
    • ManifestVariableSetId string
    • Name string
    • Priority string
    • ProjectId string
    • QueueTime string
      If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Format date-time.
    • QueueTimeExpiry string
      Format date-time.
    • RunbookId string
      Minimum length 1.
    • RunbookName string
    • RunbookSnapshotId string
      Minimum length 1.
    • SkipActions array of string
    • SpaceId string
    • SpecificMachineIds array of string
      A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.
    • SpecificTargetTagIds array of string
      A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
    • TaskId string
    • TenantId string
    • TentacleRetentionPeriod object
    • UseGuidedFailure boolean
      If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
  • ItemsPerPage integer
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • LastPageNumber integer
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • NumberOfPages integer
  • TotalResults integer

Example Response

JSON
{
  "Id": "string",
  "ItemType": "string",
  "Items": [
    {
      "ChangeRequestSettings": [
        {}
      ],
      "Comments": "string",
      "Created": "2020-01-01T00:00:00.000Z",
      "DebugMode": "string",
      "DeployedBy": "string",
      "DeployedById": "string",
      "DeployedToMachineIds": [
        "string"
      ],
      "EnvironmentId": "string",
      "ExcludedMachineIds": [
        "string"
      ],
      "ExcludedTargetTagIds": [
        "string"
      ],
      "ExecutionPlanLogContext": {
        "Steps": [
          {}
        ]
      },
      "FailTargetDiscovery": true,
      "FailureEncountered": true,
      "ForcePackageDownload": true,
      "FormValues": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "FrozenRunbookProcessId": "string",
      "Id": "string",
      "LastModifiedBy": "string",
      "LastModifiedOn": "2020-01-01T00:00:00.000Z",
      "Links": {
        "additionalProp1": "string",
        "additionalProp2": "string",
        "additionalProp3": "string"
      },
      "ManifestVariableSetId": "string",
      "Name": "string",
      "Priority": "string",
      "ProjectId": "string",
      "QueueTime": "2020-01-01T00:00:00.000Z",
      "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
      "RunbookId": "string",
      "RunbookName": "string",
      "RunbookSnapshotId": "string",
      "SkipActions": [
        "string"
      ],
      "SpaceId": "string",
      "SpecificMachineIds": [
        "string"
      ],
      "SpecificTargetTagIds": [
        "string"
      ],
      "TaskId": "string",
      "TenantId": "string",
      "TentacleRetentionPeriod": {
        "QuantityToKeep": 0,
        "ShouldKeepForever": true,
        "Strategy": "string",
        "Unit": "Days"
      },
      "UseGuidedFailure": true
    }
  ],
  "ItemsPerPage": 0,
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "LastPageNumber": 0,
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "NumberOfPages": 0,
  "TotalResults": 0
}

Create a new Runbook Run

POST /api/{spaceId}/runbookRuns

Also reachable at /api/runbookRuns, /api/spaces/{spaceIdentifier}/runbookRuns.

Path Parameters

  • spaceId string (required)

Request Body

  • ChangeRequestSettings array of object
    • Type enum
      Allowed values: ServiceNow, JiraServiceManagement.
  • Comments string
  • DebugMode string
  • EnvironmentId string (required)
  • ExcludedMachineIds array of string
  • ExcludedTargetTagIds array of string
  • FailTargetDiscovery boolean
  • ForcePackageDownload boolean
  • FormValues object
  • Priority string
  • ProjectId string
  • QueueTime string
    Format date-time.
  • QueueTimeExpiry string
    Format date-time.
  • RunbookId string (required)
  • RunbookSnapshotId string (required)
  • SkipActions array of string
  • SpaceId string (required)
  • SpecificMachineIds array of string
  • SpecificTargetTagIds array of string
  • TenantId string
  • UseGuidedFailure boolean

Response

201 — Created

  • ChangeRequestSettings array of object
    • Type enum
      Allowed values: ServiceNow, JiraServiceManagement.
  • Comments string
  • Created string
    Format date-time.
  • DebugMode string
  • DeployedBy string
  • DeployedById string
  • DeployedToMachineIds array of string
  • EnvironmentId string
  • ExcludedMachineIds array of string
    A collection of machines in the target environment that should be excluded from the deployment.
  • ExcludedTargetTagIds array of string
    A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
  • ExecutionPlanLogContext object
    • Steps array of object
  • FailTargetDiscovery boolean
  • FailureEncountered boolean
  • ForcePackageDownload boolean
  • FormValues object
  • FrozenRunbookProcessId string
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • ManifestVariableSetId string
  • Name string
  • Priority string
  • ProjectId string
  • QueueTime string
    If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Format date-time.
  • QueueTimeExpiry string
    Format date-time.
  • RunbookId string
    Minimum length 1.
  • RunbookName string
  • RunbookSnapshotId string
    Minimum length 1.
  • SkipActions array of string
  • SpaceId string
  • SpecificMachineIds array of string
    A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.
  • SpecificTargetTagIds array of string
    A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
  • TaskId string
  • TenantId string
  • TentacleRetentionPeriod object
    • QuantityToKeep integer
    • ShouldKeepForever boolean
    • Strategy string
    • Unit enum
      Allowed values: Days, Items.
  • UseGuidedFailure boolean
    If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.

Example Request

JSON
{
  "ChangeRequestSettings": [
    {
      "Type": "ServiceNow"
    }
  ],
  "Comments": "string",
  "DebugMode": "string",
  "EnvironmentId": "string",
  "ExcludedMachineIds": [
    "string"
  ],
  "ExcludedTargetTagIds": [
    "string"
  ],
  "FailTargetDiscovery": true,
  "ForcePackageDownload": true,
  "FormValues": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "Priority": "string",
  "ProjectId": "string",
  "QueueTime": "2020-01-01T00:00:00.000Z",
  "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
  "RunbookId": "string",
  "RunbookSnapshotId": "string",
  "SkipActions": [
    "string"
  ],
  "SpaceId": "string",
  "SpecificMachineIds": [
    "string"
  ],
  "SpecificTargetTagIds": [
    "string"
  ],
  "TenantId": "string",
  "UseGuidedFailure": true
}

Example Response

JSON
{
  "ChangeRequestSettings": [
    {
      "Type": "ServiceNow"
    }
  ],
  "Comments": "string",
  "Created": "2020-01-01T00:00:00.000Z",
  "DebugMode": "string",
  "DeployedBy": "string",
  "DeployedById": "string",
  "DeployedToMachineIds": [
    "string"
  ],
  "EnvironmentId": "string",
  "ExcludedMachineIds": [
    "string"
  ],
  "ExcludedTargetTagIds": [
    "string"
  ],
  "ExecutionPlanLogContext": {
    "Steps": [
      {
        "CorrelationId": "string",
        "Slug": "string"
      }
    ]
  },
  "FailTargetDiscovery": true,
  "FailureEncountered": true,
  "ForcePackageDownload": true,
  "FormValues": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "FrozenRunbookProcessId": "string",
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "ManifestVariableSetId": "string",
  "Name": "string",
  "Priority": "string",
  "ProjectId": "string",
  "QueueTime": "2020-01-01T00:00:00.000Z",
  "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
  "RunbookId": "string",
  "RunbookName": "string",
  "RunbookSnapshotId": "string",
  "SkipActions": [
    "string"
  ],
  "SpaceId": "string",
  "SpecificMachineIds": [
    "string"
  ],
  "SpecificTargetTagIds": [
    "string"
  ],
  "TaskId": "string",
  "TenantId": "string",
  "TentacleRetentionPeriod": {
    "QuantityToKeep": 0,
    "ShouldKeepForever": true,
    "Strategy": "string",
    "Unit": "Days"
  },
  "UseGuidedFailure": true
}

Get a Runbook Run by ID

GET /api/{spaceId}/runbookRuns/{id}

Also reachable at /api/runbookRuns/{id}, /api/spaces/{spaceIdentifier}/runbookRuns/{id}.

Path Parameters

  • id string (required)
    ID of the Runbook Run to load.
  • spaceId string (required)
    ID of the Space to which the Runbook Run belongs.

Query Parameters

  • projectId string
    ID of the Project to which the Runbook Run belongs.

Response

200 — The requested Runbook Run

  • ChangeRequestSettings array of object
    • Type enum
      Allowed values: ServiceNow, JiraServiceManagement.
  • Comments string
  • Created string
    Format date-time.
  • DebugMode string
  • DeployedBy string
  • DeployedById string
  • DeployedToMachineIds array of string
  • EnvironmentId string
  • ExcludedMachineIds array of string
    A collection of machines in the target environment that should be excluded from the deployment.
  • ExcludedTargetTagIds array of string
    A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
  • ExecutionPlanLogContext object
    • Steps array of object
  • FailTargetDiscovery boolean
  • FailureEncountered boolean
  • ForcePackageDownload boolean
  • FormValues object
  • FrozenRunbookProcessId string
  • Id string
    Gets or sets a unique identifier for this resource.
  • LastModifiedBy string
    Gets or sets the username of the user who last modified this resource.
  • LastModifiedOn string
    Gets or sets the date/time that this resource was last modified. Format date-time.
  • Links object
    Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.
  • ManifestVariableSetId string
  • Name string
  • Priority string
  • ProjectId string
  • QueueTime string
    If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Format date-time.
  • QueueTimeExpiry string
    Format date-time.
  • RunbookId string
    Minimum length 1.
  • RunbookName string
  • RunbookSnapshotId string
    Minimum length 1.
  • SkipActions array of string
  • SpaceId string
  • SpecificMachineIds array of string
    A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.
  • SpecificTargetTagIds array of string
    A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.
  • TaskId string
  • TenantId string
  • TentacleRetentionPeriod object
    • QuantityToKeep integer
    • ShouldKeepForever boolean
    • Strategy string
    • Unit enum
      Allowed values: Days, Items.
  • UseGuidedFailure boolean
    If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.

Example Response

JSON
{
  "ChangeRequestSettings": [
    {
      "Type": "ServiceNow"
    }
  ],
  "Comments": "string",
  "Created": "2020-01-01T00:00:00.000Z",
  "DebugMode": "string",
  "DeployedBy": "string",
  "DeployedById": "string",
  "DeployedToMachineIds": [
    "string"
  ],
  "EnvironmentId": "string",
  "ExcludedMachineIds": [
    "string"
  ],
  "ExcludedTargetTagIds": [
    "string"
  ],
  "ExecutionPlanLogContext": {
    "Steps": [
      {
        "CorrelationId": "string",
        "Slug": "string"
      }
    ]
  },
  "FailTargetDiscovery": true,
  "FailureEncountered": true,
  "ForcePackageDownload": true,
  "FormValues": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "FrozenRunbookProcessId": "string",
  "Id": "string",
  "LastModifiedBy": "string",
  "LastModifiedOn": "2020-01-01T00:00:00.000Z",
  "Links": {
    "additionalProp1": "string",
    "additionalProp2": "string",
    "additionalProp3": "string"
  },
  "ManifestVariableSetId": "string",
  "Name": "string",
  "Priority": "string",
  "ProjectId": "string",
  "QueueTime": "2020-01-01T00:00:00.000Z",
  "QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
  "RunbookId": "string",
  "RunbookName": "string",
  "RunbookSnapshotId": "string",
  "SkipActions": [
    "string"
  ],
  "SpaceId": "string",
  "SpecificMachineIds": [
    "string"
  ],
  "SpecificTargetTagIds": [
    "string"
  ],
  "TaskId": "string",
  "TenantId": "string",
  "TentacleRetentionPeriod": {
    "QuantityToKeep": 0,
    "ShouldKeepForever": true,
    "Strategy": "string",
    "Unit": "Days"
  },
  "UseGuidedFailure": true
}

Delete an existing Runbook Run

DELETE /api/{spaceId}/runbookruns/{id}

Also reachable at /api/runbookruns/{id}, /api/spaces/{spaceIdentifier}/runbookruns/{id}.

Path Parameters

  • id string (required)
    ID of the Runbook Run to delete.
  • spaceId string (required)
    ID of the Space to which the Runbook Run belongs.

Response

200 — Success